#ifndef __PARSER_HH
#define __PARSER_HH
//
// Project : webgen
// File    : parser.hh
// Purpose : functions for parsing the description file
// License : GPL
//
// arch-tag: 410be847-f9a2-427c-828d-f1b286411b63
//

#include "Menu.hh"

///////////////////////////////////////////////////
//
// defines
//
///////////////////////////////////////////////////

//
// different tokens
//

enum { TOK_NOTHING,

       TOK_EOF, TOK_SBLOCK, TOK_EBLOCK, TOK_ECMD,

       TOK_NUM, TOK_STRING, TOK_EQUAL,

       TOK_MENU, TOK_TAB, TOK_NAME, TOK_CONTENT,
       TOK_HTML, TOK_LOGO, TOK_TITLE, TOK_HEADLN,
       TOK_HEADER, TOK_FOOTER, TOK_CSS, TOK_ADDCSS,
       TOK_HIDDEN, TOK_IMPRESSUM
};

///////////////////////////////////////////////////
//
// functions
//
///////////////////////////////////////////////////

// open file
int init_parser ( const char * filename );

// return next token in stream
uint get_token ( char * value );

// parse for a specific token
int parse_token ( uint token, char * value );

// read and parse menufile and create menu
void parse ( Menu * menu, std::string & menufile );

#endif
